package com.fp.persistence.pcustomer.company;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TCUSTECONOMICGROUP*/
@Embeddable
public class TcustEconomicGroupKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="GROUPPERSONCODE", nullable=false,updatable=false)

/**
* Codigo de persona
*/
private Integer grouppersoncode;

@Column(name="PERSONCODE", nullable=false,updatable=false)

/**
* Codigo de persona
*/
private Integer personcode;

@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania
*/
private Integer companycode;

/**Contructor por defecto*/
public TcustEconomicGroupKey(){}
/**Contructor de TcustEconomicGroupKey
@param pGrouppersoncode Codigo de persona
@param pPersoncode Codigo de persona
@param pCompanycode Codigo de compania
*/
public TcustEconomicGroupKey(Integer pGrouppersoncode,Integer pPersoncode,Integer pCompanycode){
 grouppersoncode=pGrouppersoncode;
 personcode=pPersoncode;
 companycode=pCompanycode;
}
/**Obtiene el valor de grouppersoncode
@return valor de grouppersoncode*/
public Integer getGrouppersoncode(){
  return grouppersoncode;
}
/**Fija el valor de grouppersoncode
@param pGrouppersoncode nuevo Valor de grouppersoncode*/
public void setGrouppersoncode(Integer pGrouppersoncode){
  grouppersoncode=pGrouppersoncode;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Implementación de la comparación de TcustEconomicGroupKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TcustEconomicGroupKey))return false;
  TcustEconomicGroupKey that = (TcustEconomicGroupKey) o;
  if (this.getGrouppersoncode() == null || that.getGrouppersoncode() == null){
      return false;
  }
  if (! this.getGrouppersoncode().equals(that.getGrouppersoncode())){
    return false;
  }
  if (this.getPersoncode() == null || that.getPersoncode() == null){
      return false;
  }
  if (! this.getPersoncode().equals(that.getPersoncode())){
    return false;
  }
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TcustEconomicGroupKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getGrouppersoncode() == null ? 0 : this.getGrouppersoncode().hashCode());
    result = result * 37 + (this.getPersoncode() == null ? 0 : this.getPersoncode().hashCode());
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
